// flood-it.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

  int nDimension;
  int nColors;
  int board[350][350] = { 0 };

  int nSol = 0;
  int sol[350*350] = { 0 };

void parseInput() {
  FILE *pFileIn = fopen("flood-it.in","r");
  fscanf(pFileIn, "%d", &nDimension);
  fscanf(pFileIn, "%d", &nColors);
  for (int row = 0; row<nDimension; ++row) {
	  for (int col = 0; col < nDimension; ++col) {
		  fscanf(pFileIn, "%d", &board[row][col]);
	  }
  }
  fclose(pFileIn);
}

void printOutput() {
  FILE *pFileOut = fopen("flood-it.out","w");
  fprintf(pFileOut, "%d\n", nSol);
  fprintf(pFileOut, "0 0\n");
  for (int i = 0; i < nSol; ++i) {
	fprintf(pFileOut, "%d\n", sol[i]);
  }
  fclose(pFileOut);
}

int col = 1;

int findColor() {
	int result = board[0][0] + 1;
	return result > nColors ? 1: result;
}

void fillPos(int row, int col, int oldColor, int color) {
	if (row >= 0 && col >= 0 &&
		row < nDimension && col < nDimension &&
		board[row][col] == oldColor) {

        board[row][col] = color;

		fillPos(row, col - 1, oldColor, color);
		fillPos(row + 1, col, oldColor, color);
		fillPos(row - 1, col, oldColor, color);
		fillPos(row, col + 1, oldColor, color);
	}
}

bool isDone() {
	int c = board[0][0];
	  for (int row = 0; row<nDimension; ++row) {
		  for (int col = 0; col < nDimension; ++col) {
			  if (board[row][col] != c) {
				  return false;
			  }
		  }
	  }
    return true;
}

void solve() {
	/*
	nSol = 4;
	sol[0] = 3;
	sol[1] = 4;
	sol[2] = 1;
	sol[3] = 2;
	*/

	nSol = 0;
	int newColor;
	while (true) {
		newColor = findColor();
		if (isDone()
			/*newColor == board[0][0]*/) {
			break;
		} else {
			sol[nSol] = newColor;
			++nSol;
			fillPos(0, 0, board[0][0], newColor);
		}
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	parseInput();

	solve();

	printOutput();

    return 0;
}
